$typecheck on

Const crlf = CHR$(13) + CHR$(10)
' The following lines enable BOOL variable type usage
$Define Bool Integer
CONST True = 1
CONST False = 0

$include "Win32_constants.inc"
$include "C_Constants.inc"
$include "Functions.inc"


Const White = 16777215
Const Black = 0
Const Blue = 16711680
Const Red = 255


Dim apii as long
Dim apiout as long
dim winhandle as long

DECLARE FUNCTION CreateWindowEx LIB "USER32" ALIAS "CreateWindowExA" _
                 (ExStyle&, ClassName$, WindowName$, Style&, X&, Y&, _
                  Width&, Height&, WndParent&, hMenu&, hInstance&, Param&) AS LONG


DECLARE FUNCTION GetModuleHandle LIB "KERNEL32" ALIAS "GetModuleHandleA" _
                 (ModuleName AS STRING) AS LONG

Declare Function DestroyWindow Lib "user32" Alias "DestroyWindow" _
(ByVal hwnd As Long) As Long

Declare Function SetParent Lib "user32" Alias "SetParent" _
(ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Declare Function FlashWindow Lib "user32" Alias "FlashWindow" _
(ByVal hwnd As Long, ByVal bInvert As Long) As Long

Declare Function ShowWindow Lib "user32" Alias "ShowWindow" _
(ByVal hwnd As Long, ByVal nCmdShow As Long) As Long

Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
(ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Declare sub showwin
Declare sub chiudi
declare sub resize

Dim Form as qform
With form
.center
.width = 400
.onshow = Showwin
End with

Form.onresize = resize
Form.onclose = chiudi
Form.showmodal


sub showwin
' Component Registration
apii = CmUnregister()
apii = CMRegister(CM_VERSION)

' Creating editor window
winhandle = CreateWindowEx(0, _
    "CodeSense", "", WS_VISIBLE OR WS_CHILD, _
    40, 60, 200, 100, Form.handle, _
    0, GetModuleHandle(command$(0)), 0)
ShowWindow(winhandle, 3)


' Setting up the language and syntax highlighting
Dim language as string
RegisterRapidQLanguage
Cm_SetLanguage (winhandle, "RapidQ")
CM_EnableLeftMargin(winhandle, False)
CM_EnableColorSyntax (winhandle, 1)

Dim ColorSet as CM_Colors
With Colorset
     .crWindow = White
     .crLeftMargin = 14079702
     .crBookmark = 0
     .crBookmarkBk = 0
     .crText = Black
     .crTextBk = -1
     .crNumber = Red
     .crNumberBk = White
     .crKeyword =  Blue
     .crKeywordBk = -1
     .crOperator = Red
     .crOperatorBk = White
     .crScopeKeyword = Red
     .crScopeKeywordBk = White
     .crComment = 11447982
     .crCommentBk = White
     .crString = 8421440
     .crStringBk = White
     .crTagText = 256
     .crTagTextBk = White
     .crTagEntity = 256
     .crTagEntityBk = White
     .crTagElementName = 256
     .crTagElementNameBk = White
     .crTagAttributeName = 256
     .crTagAttributeNameBk = White
     .crLineNumber = Black
     .crLineNumberBk = .crLeftMargin
     .crHDividerLines = 8421440
     .crVDividerLines = 256
     .crHighlightedLine = 256
End with
Cm_SetColors(winhandle, ColorSet)


Dim Fonts as CM_FONTSTYLES
With Fonts
.byText = 0               ' plain text font style
.byNumber = 0             ' numeric literal font style
.byKeyword = 1            ' keyword font style
.byOperator = 1           ' operator font style
.byScopeKeyword = 4       ' scope keyword font style
.byComment = 2            ' comment font style
.byString = 2             ' string font style
.byTagText = 0            ' plain tag text font style
.byTagEntity = 0          ' tag entity font style
.byTagElementName = 0     ' tag element name font style
.byTagAttributeName = 0   ' tag attribute name font style
.byLineNumber = 0         ' line number font style
end With
Cm_SetFontStyles (winhandle, Fonts)

Dim LineNum as CM_LINENUMBERING
With linenum
    .bEnabled = True
    .nStartAt = 1
    .dwStyle = CM_DECIMAL
End with

Cm_SetLineNumbering(winhandle, Linenum)
End sub


Sub chiudi
apii = CmUnregister
DestroyWindow(winhandle)
End sub

Sub resize
Setparent(winhandle, form.handle)
ShowWindow(winhandle, 0)
ShowWindow(winhandle, 3)
End sub
